EDIT - bug #8025

IOException unhandled in eu.etaxonomy.cdm.common.media.Imagelnfo.readMetaData(...)
01/28/2019 12:51 PM - Andreas Kohlbecker

Status: New Start date:

Priority: New Due date:

Assignee: Andreas Kohlbecker % Done: 0%
Category: cdmlib Estimated time: 0:00 hour
Target version: Unassigned CDM tickets

Severity: normal Found in Version:

Description

2019-01-26 14:42:34,671 WARN [gtpl012570586-3112] [org.eclipse.jetty.servlet.ServletHandler] - /sa
lvador/media/38e3446d-df75-4203-a668-619d293611f6/metadata
java.io.IOException: Could not read block (block start: 42714, block length: 31151, data length: 6
5527) .

at org.apache.sanselan.common.byteSources.ByteSourceArray.getBlock (ByteSourceArray. java:47

at org.apache.sanselan.formats.tiff.TiffReader.getTiffRawImageData (TiffReader.java:461)

at org.apache.sanselan.formats.tiff.TiffReader.readDirectory (TiffReader. java:216)

at org.apache.sanselan.formats.tiff.TiffReader.readDirectory (TiffReader.java:110)

at org.apache.sanselan.formats.tiff.TiffReader.readDirectories (TiffReader.java:101)

at org.apache.sanselan.formats.tiff.TiffReader.read(TiffReader.java:448)

at org.apache.sanselan.formats.tiff.TiffReader.readContents (TiffReader.java:438)

at org.apache.sanselan.formats.tiff.TiffImageParser.getMetadata (TiffImageParser.java:124)
at org.apache.sanselan.ImageParser.getMetadata (ImageParser. java:81)

at org.apache.sanselan.formats. jpeg.JpeglmageParser.getExifMetadata (JpegImageParser. java:3

66)

at org.apache.sanselan.formats. jpeg.JpeglmageParser.getMetadata (JpegImageParser. java:307)

at org.apache.sanselan.Sanselan.getMetadata (Sanselan. java:978)

at org.apache.sanselan.Sanselan.getMetadata (Sanselan. java:923)

at org.apache.sanselan.Sanselan.getMetadata (Sanselan. java:896)

at eu.etaxonomy.cdm.common.media.ImageInfo.readMetaData (ImageInfo.java:135)

at eu.etaxonomy.cdm.common.media.ImageInfo.NewInstanceWithMetaData (ImageInfo.java:56)

at eu.etaxonomy.cdm.remote.controller.MediaController.doGetMediaMetaData (MediaController. j
ava:84)

at sun.reflect.GeneratedMethodAccessor63744.invoke (Unknown Source)

at sun.reflect.DelegatingMethodAccessorImpl.invoke (DelegatingMethodAccessorImpl. java:43)

at java.lang.reflect.Method.invoke (Method. java:498)

at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke (InvocableHandler
Method. java:222)

at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest (Invocabl
eHandlerMethod. java:137)

at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.inv
okeAndHandle (ServletInvocableHandlerMethod. java:110)

at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invo
keHandlerMethod (RequestMappingHandlerAdapter. java:814)

at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.hand
leInternal (RequestMappingHandlerAdapter. java:737)

at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle (Abstract
HandlerMethodAdapter. java:85)

at org.springframework.web.servlet.DispatcherServlet.doDispatch (DispatcherServlet.java:959

at org.springframework.web.servlet.DispatcherServlet.doService (DispatcherServlet.java:893)

at org.springframework.web.servlet.FrameworkServlet.processRequest (FrameworkServlet.java:9
69)

at org.springframework.web.servlet.FrameworkServlet.doGet (FrameworkServlet. java:860)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:687)

at org.springframework.web.servlet.FrameworkServlet.service (FrameworkServlet. java:845)

at javax.servlet.http.HttpServlet.service (HttpServlet.java:790)

at org.eclipse.jetty.servlet.ServletHolder.handle (ServletHolder.java:808)

at org.eclipse.jetty.servlet.ServletHandler$SCachedChain.doFilter (ServletHandler.java:1669)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:316)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.invoke (Filt
erSecuritylInterceptor.java:126)

at org.springframework.security.web.access.intercept.FilterSecurityInterceptor.doFilter (Fi
lterSecurityInterceptor. java:90)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.access.ExceptionTranslationFilter.doFilter (ExceptionTr
anslationFilter.java:114)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy. java:330)

at org.springframework.security.web.session.SessionManagementFilter.doFilter (SessionManage
mentFilter. java:122)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.authentication.AnonymousAuthenticationFilter.doFilter (
AnonymousAuthenticationFilter.java:111)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy. java:330)

at org.springframework.security.web.servletapi.SecurityContextHolderAwareRequestFilter.doF
ilter (SecurityContextHolderAwareRequestFilter.java:169)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.savedrequest.RequestCacheAwareFilter.doFilter (RequestC
acheAwareFilter. java:48)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.authentication.www.BasicAuthenticationFilter.doFilterI
nternal (BasicAuthenticationFilter.java:158)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.oauth2.provider.authentication.OAuth2AuthenticationProcess
ingFilter.doFilter (OAuth2AuthenticationProcessingFilter.java:176)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy. java:330)

at org.springframework.security.web.authentication.logout.LogoutFilter.doFilter (LogoutFilt
er.java:120)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.header.HeaderWriterFilter.doFilterInternal (HeaderWrite
rFilter. java:64)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.context.SecurityContextPersistenceFilter.doFilter (Secu
rityContextPersistenceFilter.java:91)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.context.request.async.WebAsyncManagerIntegrationFilter
.doFilterInternal (WebAsyncManagerIntegrationFilter.java:53)

at org.springframework.web.filter.OncePerRequestFilter.doFilter (OncePerRequestFilter. java:
107)

at org.springframework.security.web.FilterChainProxy$VirtualFilterChain.doFilter (FilterCha
inProxy.java:330)

at org.springframework.security.web.FilterChainProxy.doFilterInternal (FilterChainProxy. jav
a:213)

at org.springframework.security.web.FilterChainProxy.doFilter (FilterChainProxy.java:176)

at org.springframework.web.filter.DelegatingFilterProxy.invokeDelegate (DelegatingFilterPro
xy.Jjava:346)

at org.springframework.web.filter.DelegatingFilterProxy.doFilter (DelegatingFilterProxy. jav
a:262)

at org.eclipse. jetty.servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)

at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal (CharacterEncodi
ngFilter.java:121)
servlet.ServletHandler$CachedChain.doFilter (ServletHandler. java:1652)
servlet.ServletHandler.doHandle (ServletHandler. java:585)
server.handler.ScopedHandler.handle (ScopedHandler. java:143)
security.SecurityHandler.handle (SecurityHandler. java:577)
server.session.SessionHandler.doHandle (SessionHandler. java:223)
server.handler.ContextHandler.doHandle (ContextHandler.java:1127)
servlet.ServletHandler.doScope (ServletHandler. java:515)
server.session.SessionHandler.doScope (SessionHandler. java:185)
server.handler.ContextHandler.doScope (ContextHandler.java:1061)
server.handler.ScopedHandler.handle (ScopedHandler. java:141)
server.handler.ContextHandlerCollection.handle (ContextHandlerCollecti

server.handler.HandlerWrapper.handle (HandlerWrapper. java:97)
server.Server.handle (Server.java:497)
server.HttpChannel.handle (HttpChannel. java:310)
server.HttpConnection.onFillable (HttpConnection. java:257)
io.AbstractConnection$2.run (AbstractConnection. java:540)
util.thread.QueuedThreadPool.runJdob (QueuedThreadPool. java:635)
util.thread.QueuedThreadPool$3.run (QueuedThreadPool. java:555)

java.lang.Thread.run (Thread. java:745)

History

#1 - 01/29/2019 01:51 PM - Andreas Miiller

- Assignee changed from Andreas Mtiller to Andreas Kohlbecker

What do you want me to do here. These are you usually problems in the media themselves not in the library.

Or do you think we should upgrade our image reading library?

Or should we do better error handling?

In which context did it happen? Image Gallery? | think the portal should somehow handle the situation if metadata are not available for what ever

reason.

#2 - 01/29/2019 02:03 PM - Andreas Kohlbecker

- Assignee changed from Andreas Kohlbecker to Andreas Mtiller

| found this stacktrace in the cdm-server log.

As stated in the issue subject, | think the exception should be caught and handled.

(BTW: There is no problem in the dataportal due to this)

#3 - 01/29/2019 04:50 PM - Andreas Miuller

- Assignee changed from Andreas Muiller to Andreas Kohlbecker

Andreas Kohlbecker wrote:

| found this stacktrace in the cdm-server log.

As stated in the issue subject, | think the exception should be caught and handled.

(BTW: There is no problem in the dataportal due to this)

Ahh, sorry | did not see the "unhandled".

Anyway the problem is, that doGetMediaMetaData explicitly throws an IOException (as method). Therefore the uncatched IOException are not
handled as compile errors but are passed to the next higher level. Many/most of the controller methods do have a "throws IOException" signature.

Andreas K., as you have implemented most of the controller methods (and also this one) I give this ticket back to you. Feel free to discuss best
solution (or at least leave a message why all methods throw IOE, just curious)
